# MyTheatres.py Python client for XBMC - lives in the \xbmc\scripts\ directory
#
#
# Version 1.13 by Seanster AVB@nro.ca 10 April 2005	http://www.Seanster.com/avb
#   -requires AVB.dll version 0.13 by Seanster
# Version 1.1  by Seanster AVB@nro.ca 18 December 2004
# Version 1.0  by marplar 

############################################################
#Change your default preferences here
#Set the IP and port for the computer running MyTheatre here
URL = 'http://192.168.169.69:8000'
DEFAULT_FILE = '/list.htm?favid=3&p=0&sort=0&offset=0&name=Fun'
DEFAULT_SORT = 'by Chan'	        # 'by Chan' 'by Prog'
DEFAULT_TVRadioMode = 'TV and Radio'    # 'TV and Radio' 'TV Only' 'Radio Only'
DEFAULT_EncryptMode = 'FTA + ENC'       # 'FTA + ENC' 'FTA Only
DEFAULT_CHANNEL_CHANGE_DELAY = 5        # 5 seconds works reliably for me, but it varies
############################################################

import urllib, time, xbmc, xbmcgui, string
from HTMLParser import HTMLParser
#get actioncodes from keymap.xml
ACTION_PREVIOUS_MENU = 10
ACTION_SELECT_ITEM = 7
ACTION_SHUTOFF_Y = 8
EPG_OFFSET = 0

#Reads AVBroadcaster web page and creates list of favorite groups or channels
class MyParser(HTMLParser):

    def reset(self):
        HTMLParser.reset(self)
        self.parselist = []
        self.title = ''
        self.table_type = ''
        self.chan_data = ['','','','','','']
        self.my_chan = ''
        self.my_url = ''
        self.last_tag = ''
        self.href = ''
        
    #Read tag
    def handle_starttag(self, tag, attrs):
        #Create dictionary of tag attributes
        attrdict = dict(attrs)
        if tag == 'html':
            #Initialse list
            self.column = 0
            self.table_type = ''
            # encryption, type, name, prog, short desc, desc
            self.chan_data = ['','','','','','']
            self.parselist = []
            if self.my_chan <> '':
                self.parselist.append(['Chan', self.my_chan, self.my_url])

        # snag links
        elif tag == 'a':
            #Hyperlink tag - get link
            self.href = attrdict['href']

        # look for the tables we want to parse
        elif tag == 'table' and len(attrdict) == 5:
            self.column = 0
            if attrdict['summary'] == 'Favourites':
                self.table_type = 'Favourites'
            elif attrdict['summary'] == 'Channels':
                self.table_type = 'Channels'
            else:
                self.table_type = ''
                
        # reset the column position we are parsing
        elif tag == 'tr':
            self.column = 0

        # tr, td with 2 params = encryption status by color    
        elif tag == 'td' and len(attrdict) > 1 and self.table_type == 'Channels' and self.column == 0:
            #Table tag - check colour to determine if encrypted
            if attrdict['bgcolor'] == '#00BF00':
                self.chan_data[self.column] = ' '
            else:
                self.chan_data[self.column] = '!'

        if tag == 'td':
            if self.column == 5:
                self.column = 0
            self.column = self.column + 1
            self.chan_data[self.column] = ''

        elif tag == 'center' and self.column == 1:
            self.chan_data[self.column] = ''

        #Store tag type for data parser
        self.last_tag = tag


    #Read data (outside tag)   
    def handle_data(self,data):
        self.last_data = data

        if self.last_tag == 'a':
            if self.href[:11] == '/dvbcore.mp':
                if len(data) > 2:
                    self.my_chan = data[:20]
                    self.my_url = self.href 
                    self.parselist.append(['Chan', self.my_chan, self.my_url])

        if self.last_tag == 'title':
            if len(data) > 2:
                self.parselist.append(['Title', data])
                self.title = data

        elif self.table_type == 'Favourites':
            if self.last_tag == 'a':
                #Hyperlink data 
                if self.href[:16] == '/list.htm?favid=':
                    #Link is for favorite lists
                    if data[:9] == 'Next page' and len(self.parselist) > 10:
                        #Add next page link to list
                        self.parselist.append(['NextPage', data, self.href])
                    else:
                        # Add favorite group name and link to list
                        if len(data) > 2: 
                            self.parselist.append(['FavList', data, self.href])

        elif self.table_type == 'Channels':
            if self.last_tag == 'td' and self.chan_data[self.column] == '':
                self.chan_data[self.column] = data
                
            elif self.column == 1 and self.last_tag == 'center':
                #Get channel type (V/R)
                self.chan_data[self.column] = data
            elif self.column == 2 and self.last_tag == 'a':
                #Get channel type (V/R)
                self.chan_data[self.column] = data


    def handle_endtag(self, tag):
        if tag == 'table':
            self.table_type = ''
            
        if self.table_type == 'Channels' and tag == 'td':
                
            if self.column == 1:
                #channel type and encryption status
                #add channel type (V/R) and encrypted flag (!/ )
                foo = 0

            elif self.column == 2:
                #channel URL and Name
                chanstr = self.chan_data[1] + self.chan_data[0] + ' ' + self.chan_data[self.column]
                self.parselist.append(['Channel', chanstr, self.href])
                
            elif self.column == 3:
                # channel Program
                self.parselist.append(['Prog',  self.chan_data[self.column][:40]])

            elif self.column == 4:
                # Program Short Description
                self.parselist.append(['ShortDesc',  self.chan_data[self.column][:20]])

            elif self.column == 5:
                # Program Full Description
                self.parselist.append(['Desc',  self.chan_data[self.column][:250]])


    def close(self):
        #Return list to caller
        return self.parselist
        self.close()
        

class MyClass(xbmcgui.Window):
    def __init__(self):
        #Set default mode
        self.CSMode = 'Current Channel'
        self.TVRadioMode = DEFAULT_TVRadioMode
        self.EncryptMode = DEFAULT_EncryptMode
        self.Favourite = ''
        self.SortMode = DEFAULT_SORT
        self.list_string = ''
        self.last_tag = ''
        self.href = ''
        self.table_type = ''
        self.column = 0
        self.chan_data = ['','','','','','']
        self.cur_chan = self.CSMode
        self.cur_url =  '/dvbcore.mpg'
        self.url_list = []
        
        #Set up screen
        self.addControl(xbmcgui.ControlImage(0,0,800,600, 'background.png'))
        self.addControl(xbmcgui.ControlLabel(55, 28, 20, 35, 'my', 'font14', '0xFFFF2000'))
        self.addControl(xbmcgui.ControlLabel(82, 28, 50, 35, 'Theatre', 'font14', '0xFF800000'))
        self.strTitle = xbmcgui.ControlButton(175, 25, 275, 35, self.Favourite, 'button-focus.png', 'button-nofocus.png')
        self.addControl(self.strTitle)
        self.strSort = xbmcgui.ControlButton(500, 25, 175, 35, self.SortMode, 'button-focus.png', 'button-nofocus.png')
        self.addControl(self.strSort)
        self.butTVRadio	= xbmcgui.ControlButton(55, 50, 150, 35, self.TVRadioMode, 'button-focus.png', 'button-nofocus.png')
        self.addControl(self.butTVRadio)
        self.butEncrypt	= xbmcgui.ControlButton(235, 50, 150, 35, self.EncryptMode, 'button-focus.png', 'button-nofocus.png')
        self.addControl(self.butEncrypt)
        self.current_stream = xbmcgui.ControlButton(425, 50, 250, 35, self.cur_chan, 'button-focus.png', 'button-nofocus.png')
        self.addControl(self.current_stream)
        self.list = xbmcgui.ControlList(35, 100, 650, 350)
        self.addControl(self.list)
  
        self.strTitle.controlUp(self.list)
        self.strTitle.controlDown(self.list)
        self.strTitle.controlRight(self.strSort)

        self.strSort.controlUp(self.strTitle)
        self.strSort.controlDown(self.list)
        self.strSort.controlLeft(self.strTitle)
        self.strSort.controlRight(self.butTVRadio)
  
        self.butTVRadio.controlUp(self.strSort)
        self.butTVRadio.controlLeft(self.strSort)
        self.butTVRadio.controlRight(self.butEncrypt)
        self.butTVRadio.controlDown(self.list)

        self.butEncrypt.controlUp(self.strSort)
        self.butEncrypt.controlLeft(self.butTVRadio)
        self.butEncrypt.controlRight(self.current_stream)
        self.butEncrypt.controlDown(self.list)

        self.current_stream.controlUp(self.strSort)
        self.current_stream.controlLeft(self.butEncrypt)
        self.current_stream.controlRight(self.list)
        self.current_stream.controlDown(self.list)

        self.list.controlUp(self.list)
        self.list.controlLeft(self.current_stream)
        #self.list.controlRight(self.strTitle)
        self.list.controlDown(self.list)
        #Get favorites group list
        self.MyParser = MyParser()
        self.file = DEFAULT_FILE[:]
        dialog = xbmcgui.DialogProgress()
        dialog.create('MyTheatre', 'Retrieving Channel List')
        try:
            self.ParseList(URL)
            dialog.close()
        except:
            dialog.close()
        self.setFocus(self.list)
            

    #Read html page 
    def GetList(self,URL,file):
        opener = urllib.FancyURLopener({})
        try:
            doc = opener.open(URL + file)
            webpage = doc.read()  # read file
            doc.close()

            self.MyParser.feed(webpage)
            listings=self.MyParser.close()

            lil = len(listings)
##            if lil == 0:
##                self.message('0')
##            elif lil == 1:
##                self.message('1'+self.listings[0][0]+self.listings[0][1])
##            elif lil == 2:
##                self.message('2'+self.listings[0][0]+self.listings[0][1]+self.listings[1][0]+self.listings[1][1])
##            elif lil == 3:
##                self.message('3')
##            elif lil > 3:
##                self.message('4+')

            self.cur_chan = self.CSMode
            if lil > 0:
                if listings[0][0] == 'Chan':
                    self.cur_chan = listings[0][1]
                    self.cur_url =  listings[0][2]
                elif lil > 1:
                    if listings[1][0] == 'Chan':
                        self.cur_chan = listings[1][1]
                        self.cur_url =  listings[1][2]

            self.current_stream.setLabel( self.cur_chan )

            return listings                      
        except:
            self.message('Unable to retrieve channel list')
            return ' '

    #Check if stream is being received
    def TestChannel(self, URL):
        opener = urllib.FancyURLopener({})
        try:
            doc = opener.open(URL + '/dvbcore.mpg')
            datacount = len(doc.readline())
            doc.close
            if datacount > 0:
                return 'OK'
            else:
                return ' '
        except:
            return ' '
                   
    #Display Listing
    def ParseList(self,URL):
        #Get listings
        #
        # Implement sortmode
        #
        fyle = self.file[:]
        pos = string.find(fyle, "sort=")
        if pos >= 0:
            # there's a sort directive, set it
            if self.SortMode == 'by Chan':
                self.file = fyle[:pos+5] + '0' + fyle[pos+6:]
            else:
                self.file = fyle[:pos+5] + '1' + fyle[pos+6:]
                
        self.listings = self.GetList(URL, self.file)
        #Check if list is complete
        while self.listings[len(self.listings)-1][0] == 'NextPage':
            nextpage = self.GetList(URL, self.listings[len(self.listings)-1][2])
            self.listings.pop(len(self.listings)-1)   #Remove NextPage from original list
            nextpage.pop(0)         #Remove Title from extended list
            self.listings.extend(nextpage)   #Join original and extended lists

        #Filter Channels to show TV/Radio and FTA/Encryted
        count = 0
        list_len = len(self.listings)
        while count < list_len:
            if self.listings[count][0] == 'Channel':
                if self.ParseCheckMode(self.listings[count][1]) == 0:
                    self.listings.pop(count)
                    self.listings.pop(count)
                    self.listings.pop(count)
                    self.listings.pop(count)
                    list_len = list_len - 4
                else:
                    count = count + 1
            else:
                count = count + 1

        #Populate list
        self.list.reset()
        self.url_list = []
        list_string = ''
        list_chan = ''
        
        for listing in self.listings:
            if listing[0] == 'Title':
                self.strTitle.setLabel(listing[1])

            elif listing[0] == 'Chan':
                self.cur_chan = listing[1]
                self.cur_url =  listing[2] # '/dvbcore.mp' a or g
                self.current_stream.setLabel(self.cur_chan)
                
                
            elif listing[0] == 'Channel':
                url_string = listing[2]
                strg = listing[1]
                length = len(strg)
                while (length < 8 ): 
                    strg = strg + ' '
                    length = length + 1
                list_string = strg
                list_chan = list_string
                    
            elif listing[0] == 'Prog':
                    strg = listing[1][:35]
                    length = len(strg)
                    while (length < 35 ): 
                        strg = strg + ' '
                        length = length + 1
                    list_string = list_string + '  ' + strg
                    
            elif listing[0] == 'ShortDesc':
                    strg = listing[1][:12]
                    length = len(strg)
                    while (length < 12 ): 
                        strg = strg + ' '
                        length = length + 1
                    list_string = list_string + '  ' + strg
                    
            elif listing[0] == 'Desc':
                    list_string = list_string + '  ' + listing[1][:250]
                    self.list.addItem(list_string)
                    self.url_list.append([list_chan, url_string])
                    url_string = ''
                    list_string = ''
                    
            elif listing[0] == 'FavList':
                    self.list.addItem(listing[1])
                    self.url_list.append([listing[1], listing[2]])
                    
            #else:
                #self.list.addItem(listing[1])
                #self.list.addItem(listing[0] + ' | ' + listing[1])
                    
        #if ( list_string <> '' ):
        #    self.list.addItem(list_string)
        #    list_string = ''
            
    #Check Channel to show TV/Radio and FTA/Encryted
    def ParseCheckMode(self, listing):
        if self.TVRadioMode == 'Radio Only' and listing[0:1] <> 'R':
            return 0

        if self.EncryptMode == 'FTA Only' and (listing[1:2] == '!' and listing[0:1] <> 'R'):
            # radio is not encrypted afaik
            return 0

        if self.TVRadioMode == 'TV Only' and c:
            return 0
        elif self.TVRadioMode == 'TV and Radio':
            #if listing[0:1] <> 'V' and listing[0:1] <> 'R':
                #return 0
            #else:
            return 1
        return 1
        
    #Handle user input               
    def onControl(self, control):
        if control == self.list:
            #User selected group/channel list
            try:
                listingspos = self.list.getSelectedPosition()
                if self.url_list[listingspos][1][1:4] == 'set':
                    #User selected channel change

                    dialog = xbmcgui.DialogProgress()
                    dialog.create('MyTheatre', 'Tuning to ' +  self.url_list[listingspos][0])
                    self.GetList(URL, self.url_list[listingspos][1])

                    time.sleep(DEFAULT_CHANNEL_CHANGE_DELAY)
                    
                    #Play stream
                    dialog.close()
                    self.cur_chan = self.url_list[listingspos][0]
                    self.current_stream.setLabel( self.cur_chan )

                    #Play stream
                    time.sleep(1)
                    if self.url_list[listingspos][0:1] == 'R':
                        xbmc.Player().play(URL + '/dvbcore.mpa')
                    else:
                        xbmc.Player().play(URL + '/dvbcore.mpg')
                else:
                    #User selected group list
                    self.file = self.url_list[listingspos][1]
                    self.ParseList(URL)
            except:
                self.message('Error tuning Channel.')
                

        elif control == self.current_stream:
            xbmc.Player().play(URL + self.cur_url)

        elif control == self.butTVRadio:
            #User selected TV/Radio mode button - toggle button and display list
            if self.TVRadioMode == 'TV and Radio':
                self.TVRadioMode = 'TV Only'
            elif self.TVRadioMode == 'TV Only':
                self.TVRadioMode = 'Radio Only'
            else:
                self.TVRadioMode = 'TV and Radio'

            self.butTVRadio.setLabel(self.TVRadioMode)
            self.ParseList(URL)
            
        elif control == self.butEncrypt:
            #User selected Encrypt mode button - toggle button and display list
            if self.EncryptMode == 'FTA + ENC':
                self.EncryptMode = 'FTA Only'
            else:
                self.EncryptMode = 'FTA + ENC'

            self.butEncrypt.setLabel(self.EncryptMode)
            self.ParseList(URL)

        elif control == self.strSort:
            #User selected Encrypt mode button - toggle button and display list
            if self.SortMode == 'by Chan':
                self.SortMode = 'by Prog'
            else:
                self.SortMode = 'by Chan'

            self.strSort.setLabel(self.SortMode)
            self.ParseList(URL)

        elif control == self.strTitle:
            #User selected Favourites mode button - toggle button and display list
            #if self.listings[1][0] == 'Channel':
            self.strTitle.setLabel('Favourites')
            self.file = '/list.htm'
            self.ParseList(URL)
            self.setFocus(self.list)


    def onAction(self, action):
        if action == ACTION_PREVIOUS_MENU:
            #User selected back - show favourite groups or exit
            self.close()
        elif action == ACTION_SHUTOFF_Y:
            #User selected ahutdown
            xbmc.shutdown()

    #Display message
    def message(self, message):
        dialog = xbmcgui.Dialog()
        dialog.ok(" MyTheatre", message)

###############
#Main     
###############
mydisplay = MyClass()
mydisplay.doModal()
del mydisplay 

# EOF
